Main Page Widgets Namespaces Book

# Gdk::PixbufLoader Class Reference

Inheritance diagram for Gdk::PixbufLoader:

[legend]
List of all members.

## Public Member Functions

virtual | ~PixbufLoader ()
GdkPixbufLoader* | gobj ()
| Provides access to the underlying C GObject.
const GdkPixbufLoader* | gobj () const
| Provides access to the underlying C GObject.
GdkPixbufLoader* | gobj_copy ()
void | write (const guint8* buf, gsize count)
| Causes the pixbuf loader to parse the next count bytes of an image.
void | close ()
| Informs a pixbuf loader that no further writes with PixbufLoader::write() will occur, so that it can free its internal loading structures.
Glib::RefPtr<Gdk::Pixbuf> | get_pixbuf ()
| Queries the Gdk::Pixbuf that a pixbuf loader is currently creating.
Glib::RefPtr<Gdk::PixbufAnimation> | get_animation ()
| Queries the Gdk::PixbufAnimation that a pixbuf loader is currently creating.
Glib::SignalProxy0<void> | signal_area_prepared ()
Glib::SignalProxy4< void, int, int, int, int > | signal_area_updated ()
Glib::SignalProxy0<void> | signal_closed ()

## Static Public Member Functions

Glib::RefPtr<PixbufLoader> | create ()
| Creates a new pixbuf loader object.
Glib::RefPtr<PixbufLoader> | create (const Glib::ustring& image_type)
| Creates a new pixbuf loader object for a specific image type.

## Protected Member Functions

| PixbufLoader ()
| Constructs a pixbuf loader object.
| PixbufLoader (const Glib::ustring& image_type)
| Constructs a pixbuf loader object for a specific image type.
virtual void | on_area_prepared ()
virtual void | on_area_updated (int x, int y, int width, int height)
virtual void | on_closed ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gdk::PixbufLoader> | wrap (GdkPixbufLoader* object, bool take_copy=false)

## Constructor & Destructor Documentation

virtual Gdk::PixbufLoader::~PixbufLoader | ( |  | ) | `[virtual]`

Gdk::PixbufLoader::PixbufLoader | ( |  | ) | `[protected]`

| Constructs a pixbuf loader object.

Gdk::PixbufLoader::PixbufLoader | ( | const Glib::ustring& | image_type | ) | `[explicit, protected]`

Constructs a pixbuf loader object for a specific image type.

Constructs a new pixbuf loader object that always attempts to parse image data as if it were an image of type image_type, instead of identifying the type automatically. Useful if you want an error if the image isn't the expected type, for loading image formats that can't be reliably identified by looking at the data, or if the user manually forces a specific type.

Parameters:

  image_type | Name of the image format to be loaded with the image.

Exceptions:

  Gdk::PixbufError |

## Member Function Documentation

void Gdk::PixbufLoader::close | ( |  | ) |

Informs a pixbuf loader that no further writes with PixbufLoader::write() will occur, so that it can free its internal loading structures.

Also, tries to parse any data that hasn't yet been parsed; if the remaining data is partial or corrupt, an exception will be thrown. If you're just cancelling a load rather than expecting it to be finished, writing an empty `catch()` block to ignore errors is reasonable.

Exceptions:

  Gdk::PixbufError |
  Glib::FileError |

Glib::RefPtr<PixbufLoader> Gdk::PixbufLoader::create | ( | const Glib::ustring& | image_type | ) | `[static]`

Creates a new pixbuf loader object for a specific image type.

Creates a new pixbuf loader object that always attempts to parse image data as if it were an image of type image_type, instead of identifying the type automatically. Useful if you want an error if the image isn't the expected type, for loading image formats that can't be reliably identified by looking at the data, or if the user manually forces a specific type.

Parameters:

  image_type | Name of the image format to be loaded with the image.

Returns:
  A newly-created pixbuf loader.

Exceptions:

  Gdk::PixbufError |

Glib::RefPtr<PixbufLoader> Gdk::PixbufLoader::create | ( |  | ) | `[static]`

Creates a new pixbuf loader object.

Returns:
  A newly-created pixbuf loader.

Glib::RefPtr<Gdk::PixbufAnimation> Gdk::PixbufLoader::get_animation | ( |  | ) |

Queries the Gdk::PixbufAnimation that a pixbuf loader is currently creating.

In general it only makes sense to call this function after the "area_prepared" signal has been emitted by the loader. If the loader doesn't have enough bytes yet (hasn't emitted the "area_prepared" signal) this function will return `0`.

Returns:
  The Gdk::PixbufAnimation that the loader is loading, or `0` if not enough data has been read to determine the information.

Glib::RefPtr<Gdk::Pixbuf> Gdk::PixbufLoader::get_pixbuf | ( |  | ) |

Queries the Gdk::Pixbuf that a pixbuf loader is currently creating.

In general it only makes sense to call this function after the "area_prepared" signal has been emitted by the loader; this means that enough data has been read to know the size of the image that will be allocated. If the loader has not received enough data via write(), then this function returns `0`. The returned pixbuf will be the same in all future calls to the loader, so simply calling Glib::object_ref() should be sufficient to continue using it. Additionally, if the loader is an animation, it will return the "static image" of the animation (see Gdk::PixbufAnimation::get_static_image()).

Returns:
  The Gdk::Pixbuf that the loader is creating, or `0` if not enough data has been read to determine how to create the image buffer.

const GdkPixbufLoader* Gdk::PixbufLoader::gobj | ( |  | ) | const`[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GdkPixbufLoader* Gdk::PixbufLoader::gobj | ( |  | ) | `[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GdkPixbufLoader* Gdk::PixbufLoader::gobj_copy | ( |  | ) |

virtual void Gdk::PixbufLoader::on_area_prepared | ( |  | ) | `[protected, virtual]`

virtual void Gdk::PixbufLoader::on_area_updated | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) | `[protected, virtual]`

virtual void Gdk::PixbufLoader::on_closed | ( |  | ) | `[protected, virtual]`

Glib::SignalProxy0<void> Gdk::PixbufLoader::signal_area_prepared | ( |  | ) |

Prototype:
  `void area_prepared()`

Glib::SignalProxy4<void,int,int,int,int> Gdk::PixbufLoader::signal_area_updated | ( |  | ) |

Prototype:
  `void area_updated(int x, int y, int width, int height)`

Glib::SignalProxy0<void> Gdk::PixbufLoader::signal_closed | ( |  | ) |

Prototype:
  `void closed()`

void Gdk::PixbufLoader::write | ( | const guint8* | buf,
|  | gsize | count
| ) |

Causes the pixbuf loader to parse the next count bytes of an image.

It will return if the data was loaded successfully, and throw an exception if an error occurred. In the latter case, the loader will be closed, and will not accept further writes.

Parameters:

  buf | Pointer to image data.
  count | Length of the buf buffer in bytes.

Exceptions:

  Gdk::PixbufError |
  Glib::FileError |

## Friends And Related Function Documentation

Glib::RefPtr<Gdk::PixbufLoader> wrap | ( | GdkPixbufLoader* | object,
|  | bool | take_copy = false
| ) | `[related]`

The documentation for this class was generated from the following file:

- pixbufloader.h